//+------------------------------------------------------------------+
//|                                              Dredding_Signal.mq4 |
//|                  Modified by Matsu, from #MTF Supertrend Bar.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 5
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_color7 Red
#property indicator_color8 Lime

//---- parameters
extern bool    alert          = true;
extern int     BarWidth       = 0;
extern color   BarColorUp     = Lime;
extern color   BarColorDown   = Red;
extern color   TextColor      = White;
extern int     MaxBars        = 500;

//---- Global Variables
double   Gap         = 1;                                            // Gap between the lines of bars
string   shortname   = "";                                           // name of the indicator window
int      ArrowUp     = 110;                                          // arrow code for an up arrow
int      ArrowDn     = 110;                                          // arrow code for an down arrow
int      UniqueNum   = 2282;                                         // uniquely identify objects
int      Period_1, Period_2;                                         // identify the timefames in play
datetime LastAlert;

//---- buffers
double buf1_up[];                                                    // current timeframe * 4 Hieken Ashi
double buf1_down[];

double buf2_up[];                                                    // current timeframe * 4 Stochastic
double buf2_down[];

double buf3_up[];                                                    // current timeframe Hieken Ashi
double buf3_down[];

double buf4_up[];                                                    // current timeframe Stochastic
double buf4_down[];

double ha4Buffer1[9999];                                             // values for current period * 4 heiken ashi calculations
double ha4Buffer2[9999];
double ha4Buffer3[9999];
double ha4Buffer4[9999];

double st4Buffer1[9999];                                             // values for current period * 4 Stochastic calculations
double st4Buffer2[9999];

double ha0Buffer1[9999];                                             // values for current period heiken ashi calculations
double ha0Buffer2[9999];
double ha0Buffer3[9999];
double ha0Buffer4[9999];

double st0Buffer1[9999];                                             // values for current period Stochastic calculations
double st0Buffer2[9999];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   // current period * 4 Hieken Ashi 
   SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(0,ArrowUp);
   SetIndexBuffer(0,buf1_up);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(1,ArrowDn);
   SetIndexBuffer(1,buf1_down);
   SetIndexEmptyValue(1,0.0);

   // current period * 4 stochastic 
   SetIndexStyle(2,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(2,ArrowUp);
   SetIndexBuffer(2,buf2_up);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(3,ArrowDn);
   SetIndexBuffer(3,buf2_down);
   SetIndexEmptyValue(3,0.0);

   // current period Hieken Ashi 
   SetIndexStyle(4,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(4,ArrowUp);
   SetIndexBuffer(4,buf3_up);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(5,ArrowDn);
   SetIndexBuffer(5,buf3_down);
   SetIndexEmptyValue(5,0.0);

   // current period stochastic 
   SetIndexStyle(6,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(6,ArrowUp);
   SetIndexBuffer(6,buf4_up);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(7,ArrowDn);
   SetIndexBuffer(7,buf4_down);
   SetIndexEmptyValue(7,0.0);
   
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);
   
   IndicatorDigits(0);
   getPeriod();
   
   shortname = "Dredding Signal (" + tf2txt(Period_1) + ", " + tf2txt(Period_2) + ")";
   IndicatorShortName(shortname);
   
   for(int i=0;i<=9999;i++)
   {
      ha4Buffer1[i] = 0;
      ha4Buffer2[i] = 0;
      ha4Buffer3[i] = 0;
      ha4Buffer4[i] = 0;
      
      st4Buffer1[i] = 0;
      st4Buffer2[i] = 0;
      
      ha0Buffer1[i] = 0;
      ha0Buffer2[i] = 0;
      ha0Buffer3[i] = 0;
      ha0Buffer4[i] = 0;

      st0Buffer1[i] = 0;
      st0Buffer2[i] = 0;
   }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   //int limit= MathMin(Bars-counted_bars, MaxBars);                   // loop for the smallest number of bars
   int limit= Bars - counted_bars;
   
   int i,tf, pos;
   double   haOpen, haClose, haHigh, haLow, op, hi, lo, cl, stochBase, stochSig;

   //-------------------------------0----------------------------------------
   // Initialisation   
   //-------------------------------0----------------------------------------   
   double dif = Time[0] - Time[1];
   
   for ( i=ObjectsTotal()-1; i>-1; i--)
   {
      if (StringFind(ObjectName(i),"FF_"+UniqueNum+"_") >= 0)  ObjectDelete(ObjectName(i));
   }
      
  string name = "FF_" + UniqueNum + "_1_" + tf2txt(Period_2) + "_HA";
   ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0) + dif*3, 4.5);
   ObjectSetText(name, tf2txt(Period_2) + "_HA",8,"Arial", TextColor);

   name = "FF_" + UniqueNum + "_1_" + tf2txt(Period_2) + "_Stoch";
   ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0) + dif*3, 3.5);
   ObjectSetText(name, tf2txt(Period_2) + "_Stoch",8,"Arial", TextColor);

   name = "FF_" + UniqueNum + "_1_" + tf2txt(Period_1) + "_HA";
   ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0) + dif*3, 2.5);
   ObjectSetText(name, tf2txt(Period_1) + "_HA",8,"Arial", TextColor);

   name = "FF_" + UniqueNum + "_1_" + tf2txt(Period_1) + "_Stoch";
   ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0) + dif*3, 1.5);
   ObjectSetText(name, tf2txt(Period_1) + "_Stoch",8,"Arial", TextColor);

   //-------------------------------1----------------------------------------   
   // Current Period * 4 Hieken Ashi
   //-------------------------------1----------------------------------------   

   pos = limit;

   while(pos>=0)
     {
      buf1_up[pos] = EMPTY_VALUE;
      buf1_down[pos] = EMPTY_VALUE;
      op = iOpen(Symbol(), Period_2, pos);
      cl = iClose(Symbol(), Period_2, pos);
      hi = iHigh(Symbol(), Period_2, pos);
      lo = iLow(Symbol(), Period_2, pos);
      haOpen=(ha4Buffer3[pos+1] + ha4Buffer4[pos+1])/2;
      haClose=(op + hi + lo + cl)/4;
      haHigh=MathMax(hi, MathMax(haOpen, haClose));
      haLow=MathMin(lo, MathMin(haOpen, haClose));
      if (haOpen<haClose) 
        {
         ha4Buffer1[pos]=haLow;
         ha4Buffer2[pos]=haHigh;
         buf1_up[pos] = 4;
         //buf1_down[pos] = 0;
        } 
      else
        {
         ha4Buffer1[pos]=haHigh;
         ha4Buffer2[pos]=haLow;
         //buf1_up[pos] = 0;
         buf1_down[pos] = 4;
        } 
      ha4Buffer3[pos]=haOpen;
      ha4Buffer4[pos]=haClose;
 	   pos--;
     }

   //-------------------------------2----------------------------------------   
   // Current Period * 4 Stochastic
   //-------------------------------2----------------------------------------   

   pos = limit;

   while(pos>=0)
   {
      buf2_up[pos] = EMPTY_VALUE;
      buf2_down[pos] = EMPTY_VALUE;
      stochBase = iStochastic(Symbol(), Period_2, 10, 3, 3, MODE_SMA, 1, 0, pos);
      stochSig  = iStochastic(Symbol(), Period_2, 10, 3, 3, MODE_SMA, 1, 1, pos);

      if (stochSig < stochBase) 
        {
         buf2_up[pos] = 3;
         //buf2_down[pos] = 0;
        } 
      else
        {
         //buf2_up[pos] = 0;
         buf2_down[pos] = 3;
        } 

      st4Buffer1[pos] = stochBase;
      st4Buffer2[pos] = stochSig;
  	   pos--;
   }

   //-------------------------------3----------------------------------------   
   // Current Period Hieken Ashi
   //-------------------------------3----------------------------------------   
   pos = limit;

   while(pos>=0)
     {
      buf3_up[pos] = EMPTY_VALUE;
      buf3_down[pos] = EMPTY_VALUE;
      op = iOpen(Symbol(), Period_1, pos);
      cl = iClose(Symbol(), Period_1, pos);
      hi = iHigh(Symbol(), Period_1, pos);
      lo = iLow(Symbol(), Period_1, pos);
      haOpen=(ha0Buffer3[pos+1] + ha0Buffer4[pos+1])/2;
      haClose=(op + hi + lo + cl)/4;
      haHigh=MathMax(hi, MathMax(haOpen, haClose));
      haLow=MathMin(lo, MathMin(haOpen, haClose));
      //Print("pos ",pos,"; op ",op,"; cl ",cl,"; hi ",hi,"; lo ",lo,"; haop ",haOpen,"; hacl ",haClose,"; hahi ",haHigh,"; halo ", haLow);
      if (haOpen<haClose) 
        {
         ha0Buffer1[pos]=haLow;
         ha0Buffer2[pos]=haHigh;
         buf3_up[pos] = 2;
         buf3_down[pos] = EMPTY_VALUE;
        } 
      else
        {
         ha0Buffer1[pos]=haHigh;
         ha0Buffer2[pos]=haLow;
         buf3_up[pos] = EMPTY_VALUE;
         buf3_down[pos] = 2;
        } 
      ha0Buffer3[pos]=haOpen;
      ha0Buffer4[pos]=haClose;
 	   pos--;
     }

   //-------------------------------4----------------------------------------   
   // Current Period Stochastic
   //-------------------------------4----------------------------------------   

   pos = limit;

   while(pos>=0)
   {
      buf4_up[pos] = EMPTY_VALUE;
      buf4_down[pos] = EMPTY_VALUE;
      stochBase = iStochastic(Symbol(), Period_1, 10, 3, 3, MODE_SMA, 1, 0, pos);
      stochSig  = iStochastic(Symbol(), Period_1, 10, 3, 3, MODE_SMA, 1, 1, pos);

      if (stochSig < stochBase) 
        {
         buf4_up[pos] = 1;
         //buf4_down[pos] = 0;
        } 
      else
        {
         //buf4_up[pos] = 0;
         buf4_down[pos] = 1;
        } 

      st0Buffer1[pos] = stochBase;
      st0Buffer2[pos] = stochSig;
  	   pos--;
   }

   //-------------------------------5----------------------------------------   
   // Alerts
   //-------------------------------5----------------------------------------   

   if(alert==false) return(0);
   
   bool up = true;
   
   if(Time[0]>LastAlert)
   {
      // 1) ZZ Semafor On TOP(Within 1-3 Candles)
      // not coded for
  
      // 2) Failed At Pivot
      // not coded for

      // 3) Stoch Crossed
      if(buf4_up[2] == buf4_up[1]) LastAlert = Time[0]; return(0);    // not crossed

      if((buf4_up[2] == 1 && buf4_up[1] == 0))
      {
         up = false;       //crossed down
         Print("Dredding Signal Alert (", Symbol(), ", ", Period(), ")-- Stoch Crossed Down");
      } else {
         up = true;        //crossed up
         Print("Dredding Signal Alert (", Symbol(), ", ", Period(), ")-- Stoch Crossed Up");
      }

   // 4) HA Candle Closed RED
      if((buf3_down[1] == 2 && up == true) || (buf3_up[1] == 2 && up == false)) LastAlert = Time[0]; return(0);
      Print("Dredding Signal Alert (", Symbol(), ", ", Period(), ")-- Passed rule 4");

   // 5) Trade with the trend
      if(up==true)
      {
         if(buf1_up[1] == 0 || buf2_up[1] == 0) LastAlert = Time[0]; return(0);
         Print("Dredding Signal Alert (", Symbol(), ", ", Period(), ")-- Higher TFs Green");
      } else {
         if(buf1_down[1] == 0 || buf2_down[1] == 0) LastAlert = Time[0]; return(0);
         Print("Dredding Signal Alert (", Symbol(), ", ", Period(), ")-- Higher TFs Red");
      }   

   // valid possible signal
      name = "FF_" + UniqueNum + "_" + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES);

         Print("Dredding Signal Alert (", Symbol(), ", ", Period(), ")-- Alert coming!");
         if(up==true)
         {
            Alert("Dredding Signal Alert (", Symbol(), ", ", Period(), ")--Possible BUY ");
            PlaySound("Alert2.wav");
            ObjectCreate(name, OBJ_ARROW, 0, Time[1], Low[1] - (20 * Point));
            ObjectSet(name, OBJPROP_ARROWCODE, 241);
            ObjectSet(name, OBJPROP_COLOR, BarColorUp);
            ObjectSet(name, OBJPROP_WIDTH, 4);         
         } else {
            Alert("Dredding Signal Alert (", Symbol(), ", ", Period(), ")--Possible SELL ");
            PlaySound("Alert2.wav");
            ObjectCreate(name, OBJ_ARROW, 0, Time[1], High[1] + (20 * Point));
            ObjectSet(name, OBJPROP_ARROWCODE, 242);
            ObjectSet(name, OBJPROP_COLOR, BarColorDown);
            ObjectSet(name, OBJPROP_WIDTH, 4);         
      }
      LastAlert = Time[0];
   }

//----
   return(0);
  }
  
  
  
//+------------------------------------------------------------------+
void getPeriod()
//+------------------------------------------------------------------+
{
   switch(Period()) 
      {
         case 1: 
            Period_1=1; Period_2=5; 
            break;
         case 5: 
            Period_1=5; Period_2=30;
            break;
         case 15: 
            Period_1=15; Period_2=60;
            break;
         case 30: 
            Period_1=30; Period_2=240;
            break;
         case 60: 
            Period_1=60; Period_2=240;
            break;
         case 240: 
            Period_1=240; Period_2=1440;
            break;
         case 1440: 
            Period_1=1440; Period_2=10080;
            break;
         case 10080: 
            Period_1=10080; Period_2=43200; 
            break;
         case 43200: 
            Period_1=43200; Period_2=43200; 
            break;
         
      }
} // getPeriod

//+------------------------------------------------------------------+
string tf2txt(int tf)
//+------------------------------------------------------------------+
{
   if (tf == PERIOD_M1)    return("M1");
   if (tf == PERIOD_M5)    return("M5");
   if (tf == PERIOD_M15)   return("M15");
   if (tf == PERIOD_M30)   return("M30");
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
   if (tf == PERIOD_D1)    return("D1");
   if (tf == PERIOD_W1)    return("W1");
   if (tf == PERIOD_MN1)   return("MN");
   
   return("??");
} // tf2txt



